
******************************************************************
* LZD v0.4b (03/2009)
* HP48/49 Compressor
* MASD Code by Yann Collet
******************************************************************

*****************************************************
**     Compression Code
*****************************************************
CODEM

  GOSBVL =POP#           % A.A = OSIZE ( Note : C.A & D.A modifis , D1 utilis
  R3=A.W

  GOSBVL =SAVPTR         % Save B.A, D.A, D0 & D1; dtruit C
  A=DAT1.A               % Adresse Objet
  R2=A.W

% Create Temporary Memory
  A=R3.W C=A.A
  ASR.A A+C.A            % MCompress = Source + Source/16
  LC(5)(LINK_TABLE_SIZE+30)  % Chain_link table + Margin
  A+C.A R1=A.W           % ->TMatch
  LC(5)DISPATCH_TABLE_SIZE   % Dispatch table size
		C+A.A                  % MCompress + LINK_TABLE_SIZE + Dispatch
  R4=C.W                 % TempOb Size (for WipeOut)
  GOSBVL =MAKE$N         % Creates character string in tempob area ;
                         % C.A = nibbles -> D0 = addr of body of $
                         % Note : modify A.W,B.W,C.W,D.W,R0,D0&D1

  CD0EX D1=C             % -> CString
  CR4EX.W                % C.A = TempObSize; R4=->String
  GOSBVL =WIPEOUT        % Zeroes C.A nibbles at D1; Uses A.W C.A P D1
  C=R2.W D0=C            % Init Pointer Object
  C=R4.W D1=C
  A=R1.W A+C.A           % -> TMatch
  GOSBVL =CSLW5
  C=A.A R1=C.W           % Save ->Match;->CString

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% R1 : -> Match , -> CString.Start
% R3 : -> SourceEnd
% D0 : -> Source
% D1 : -> CString
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  C=0.W R2=C.W                 % Init Uncompressed Sequence
  D=0.W                        % D.S = USequence.Counter
  B=0.W                        % B.S = LazyCheck

*.WriteHeader
  LC(3)HEADER DAT1=C.X D1+3
  C=R3.W DAT1=C.A D1+5         % Object Size
  AD0EX D0=A A+C.A R3=A.W      % R3=EndSourceAddress

*.StartCompression
		D0-1
		GOTO .CompressionMainLoop

% Ici, on place le rsultat sur la pile
*.PutResultOnStack
  C=R1.W GOSBVL =CSRW5 C-10.A R0=C.W
  AD1EX AD0EX                  % D0 = End of CString pour =Shrink$
  GOSBVL =Shrink$
  GOVLNG =GPOverWrR0Lp

*.FlushLiterals
		C=RSTK D1=C                % Restore ->CString
		C=RSTK                     % Start of Literals
		AD0EX D0=C                 % D0 = LiteralStart
		C=A-C.A                    % Literals length
		?C=0.A
		{ D=C.A ST=1.FLAG_LITERAL_LOOP
		  { LC(5)15 ?D<C.A ->{ C=D.A ST=0.FLAG_LITERAL_LOOP } D-15.A
      DAT1=C.1 D1+1
	     GOSBVL =MOVEDOWN       % Copy downwards C.A nibbles from D0 to D1; Update D0 & D1
	     ?ST=1.FLAG_LITERAL_LOOP UP }
	 }
	 GOTO .PutResultOnStack     % Always NC (test = false)
	
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Compression Main Loop
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% D.A : USequence Counter
% R0.A : Save ->Source
% R1.A : ->MatchTables  ->CString.Start
% R2.0 : Best MatchSequence
% R3.A : ->SourceEnd
% R4.0 : Current MatchSequence
% D0 : ->Source
% D1 : ->CString
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
*.CompressionMainLoop

% 1) Search until a Match is found
		CD0EX D0=C                  % C = D0
		C+1.A RSTK=C                % Save Start of Literals
		CD1EX RSTK=C
		{ D0+1
    CD0EX D0=C A=R3.A ?C>=A.A -> .FlushLiterals
	   GOSUB .FindBestMatch      % out : A.X = MatchLength; C.A = Remaining Nibbles
				UPC }	

%2) Now, we have a Match at D0
%   Start Lazy Matching	
		{ D0+1 GOSUB .FindBetterMatch      % Out: A.X = MatchLength
		  UPNC
		  D0+1 GOSUB .FindBetterMatch      % Out: A.X = MatchLength
		  UPNC
		  D0+1 GOSUB .FindBetterMatch      % Out: A.X = MatchLength
		  UPNC
				}
		D0-3

%3) Write Literals
		C=RSTK D1=C		               % Restore D1 ->CString
		C=RSTK                      % Start of Literals
		AD0EX                       % Current Position
		D0=C                        % Start of Literals
		C=A-C.A                     % Literals length
		D=C.A ST=1.FLAG_LITERAL_LOOP
		{ LC(5)15 ?D<C.A ->{ C=D.A ST=0.FLAG_LITERAL_LOOP } D-15.A
    DAT1=C.1 D1+1
	   GOSBVL =MOVEDOWN          % Copy downwards C.A nibbles from D0 to D1; Update D0 & D1
	   ?ST=1.FLAG_LITERAL_LOOP UP }

%4) Write Match Sequence		
  P=5 A=R2.WP                      % Get Offset / MatchLength
  B=A.X                            % B.X = MatchLength
  C=B.X D=C.X                      % D.X = Matchlength
  ASR.WP ASR.A P=0 A=0.P ASRB.A    % A.X = Offset at Ready-to-write position
		A-8.X                            % -1
		B-"MINMATCH".X                   % - MinMatch
  LC(3)7 ?C=B.X ->{ B-1.P D-1.X }  % Exclu B.X=7 (donc Match=11)
  ?B<C.X ->{ A+B.P DAT1=A.3 D1+3 } % Write Offset-Match Sequence if B.X<7
  SKELSE
  { A+7.P DAT1=A.3 D1+3 B-8.X
    { LA(3) 15 ?B=A.X ->{ B-1.P D-1.X }
      ?B>A.X { A=B.P B=0.P } SKELSE { B-16.X }   % Maximum MatchLength ( Echelle 4-19 )
      DAT1=A.1 D1+1             % Write MatchLengthCode
      A+1.P UPC }
  }

%5) Adding Entries
	 D0+3 D-4.X                    % Version for LazyMatch Depth 3
		D-1.X SKIPC
  { CD1EX RSTK=C                % Save D1
  { D0+1 GOSUB .AddEntryD0 D-1.X UPNC }
  C=RSTK D1=C }                 % Restore D1

%6) Continue Compression
  GOTO .CompressionMainLoop
	
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Find Best Match
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% IN : D0 : Current source position
%      R0 : Available to save D0
%      R1 : -> MatchTables
%      R3 : End of File
%      R4 : MatchLength / Offset (if BetterMatch)
% OUT: R4 : MatchLength / Offset if better
%      R2 : Best MatchLength / Offset (updated)
%      Carry if no better
% Uses : D1 ->TestMatch
%        A.W, B.A, C.W, D.A
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
*.FindBestMatch
		P=5 C=0.WP R2=C.WP P=0       % Init R2 (SaveBestMatch)
  LC(1)(MINMATCH-1) R4=C.X     % Init R4 (CurrentBestMatch)
*.FindBetterMatch
		AD0EX D0=A R0=A.A            % save ->Source into R0

% D0 : -> CurrentSource
% D1 : -> TestMatch

  GOSUB .AddEntryD0 RTNC       % Carry si C=0

		ST=0.FLAG_BETTER_MATCH
	 D=C.A		                      % D = FirstMatchPos
  A=R0.A                       % A = D0 = CurrentPosition
  LC(5)MAX_OFFSET C=A-C.A      % C = MaxAutorisedMatchPosition
		?D<C.A
		{ CDEX.A                     % D = MaxAutorisedMatchPosition
		{ D1=C GOSUB .CountSequence P=0  % Carry if no better
  		% Get Next Match position
  		AD1EX                      % A = D1(CurrentMatch)
    LC(5)LINK_TABLE_MASK A&C.A % Pos MOD Link_Table_Size
    C=R1.A C-A.A A+A.X A+A.X C-A.A   % Pos x 5 ->MatchTables
    CD1EX                      % D1 : Position du Match
    C=DAT1.A                   % C = MatchPrcdent
	  	?C>=D.A UP }               % Tant que C(NextMatch)>D(MaxOffsetPos), on continue
		}

		?ST=0.FLAG_BETTER_MATCH RTNYES  % Carry : No Better

% Check EOF (Matchlength must not go beyond)		
		A=R0.A C=R3.A C-A.A          % C.A = Remaining nibbles
  A=0.A A=R4.X                 % A.A = Current MatchLength
  ?A>C.A ->{                   % Do not overwrite beyond ObjectSize
				R4=C.X
		  C-"MINMATCH".X RTNC        % Minimum MINMATCH; if not -> Carry
				}
  C=R2.X P=5 A=R4.WP
  ?A<=C.X                      % Carry No Better
		  { R2=A.WP }                % No Carry : Better
		P=0 RTN

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% D.A : -> CString
% D.S : USequence Counter
% R0.A : Save ->Source
% R1.A : -> TMatch
% R1.5 : -> CString.Start
% R2.0 : Saved MatchSequence
% R3.A : -> SourceEnd
% R4.0 : Current MatchSequence
% D0 : -> Source
% D1 : -> CurrentTest
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Count Sequence
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% IN : D0 : Source Position
%      D1 : Match Position
%      R0 : Source Position
% OUT: R4 : MatchLength / Offset if better
%      Carry if no better / No Carry & ST=1.FLAG_BETTER_MATCH if better
%      P in unknown state : to reset !
% Uses : A.W, B.A, C.W
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
*.P15
		A=DAT1.16 C=DAT0.16          % / 33 33
		?A#C.W RTNYES                % Carry : No better / (29)
		P=0 LC(5)16 B=C.A            % / 2 ? ?
		D0+16
		GONC .StartCounting          % Always Not Carry car A=C.W

*.CountSequence
  C=R4.X                       % / 9
  CPEX.0 ?C#0.X -> .P15        % / 6 (9-16)
*.Comparison
  A=DAT1.WP C=DAT0.WP          % / (21) (21)
  ?A#C.WP RTNYES               % Carry : No better / (10-17)
  P+1 C=P.0 P=0                % P+1 valid car P#15 / 3 6 2
  B=0.A B=C.P                  % / 7 4
  CD0EX C+B.A CD0EX            % / 8 7 8
*.StartCounting
  CD1EX RSTK=C C+B.A CD1EX      % / 8 8 7 8
  { A=DAT1.A C=DAT0.A          % / 18 18
    ?A#C.A EXIT                % / (?-19)
    B+5.X D0+5 D1+5
    UP }
  {     ?A#C.P EXIT            % P=0 / (7-14)
    P=1 ?A#C.P -> .Add1        % P=1 / 2 (7-14)
    P=2 ?A#C.P -> .Add2        % P=2
    P=3 ?A#C.P -> .Add3        % P=3
       B+4.X EXITNC            % Note : c'est le max possible puisque A#C.A
*.Add3 B+3.X EXITNC
*.Add2 B+2.X EXITNC
*.Add1 B+1.X                   % / 6
    }
% Restore
 	C=RSTK D1=C                  % C=Pos, Restore D1  /  8 8
		A=R0.A D0=A                  % Restore -> Source  / 11 8
  C=A-C.A                      % Delta = D0 - D1    / 7
% Result : Not necessarily better ( if > #Fh )
  A=R4.X                       % A.X = R4.X = PreviousMatchLength
		?A>=B.X RTNYES               % Carry : No Better
% Save Result if MatchLength(B.X)>PreviousMatchLength
  CSL.A CSL.A P=5 CSL.WP       % C.3=Delta
  C=B.X R4=C.WP
  ST=1.FLAG_BETTER_MATCH
  RTN                          % No Carry => better

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% D.A : USequence Counter
% R0.A : Save ->Source
% R1.A : -> TMatch
% R1.5 : -> CString.Start
% R2.0 : Saved MatchSequence
% R3.A : Object Size
% R4.0 : Current MatchSequence
% D0 : -> Source
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% C.A = Entry -> Address
*.AddEntryD0                  % Uses A.A, D1
% TableEntry
		C=DAT0.A
		A=C.X                       % / 6
		CSR.A                       % / 8
  CSRB.X CSRB.X               % / 11 11
		A+C.X                       % A:[0..4095] / 6
  LC(5)HASH_MASK A&C.A        % A:[0..1023] / ? ?
  C=R1.A C+A.A A+A.X A+A.X C+A.A    % / 11 7 6 6 7
  D1=C D1+5                   % D1 = R1+5A+5 -> Match.Dispatch / 8 7
% Write New Entry
  C=DAT1.A                    % A = PrevMatch / 18
  AD0EX D0=A                  % C.A = D0 (->Source)
  DAT1=A.A
		?C=0.A RTNYES               % Donc Carry
		?A=0.B -> .BuzzySignal
*.LinkMatchChain
  CD1EX                       % D1 = PrevMatch
  LC(5)LINK_TABLE_MASK A&C.A  % A = D0 MOD 512
  C=R1.A C-A.A A+A.X A+A.X C-A.A   % Pos x 5
  CD1EX                       % D1 : Case; C = PrevMatch
  DAT1=C.A
  RTN

*.BuzzySignal
  D1=(5)  =ANNCTRL
  P=2 DAT1=C.P P=0
  GOTO .LinkMatchChain

ENDCODE

